    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ------------------
    028 * ObjectFactory.java
    029 * ------------------
    030 * (C) Copyright 2003-2005, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: ObjectFactory.java,v 1.3 2005/10/18 13:33:53 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 22-Nov-2003 : Version 1 (TM);
    040 *
    041 */
    042
    043package org.jfree.xml.util;
    044
    045/**
    046 * An object factory.
    047 */
    048public interface ObjectFactory {
    049
    050    /**
    051     * Returns the generic factory for the given class or null, if there is
    052     * no handler for this class. The factory will be reinitialized using
    053     * getInstance().
    054     *
    055     * @param c the class for which we need a producer
    056     * @return the factory for this class
    057     */
    058    public GenericObjectFactory getFactoryForClass(Class c);
    059
    060    /**
    061     * Checks, whether a generic handler exists for the given class. This does
    062     * not check, whether an mapping exists.
    063     *
    064     * @param c the class for which to check
    065     * @return true, if an generic handler is defined, false otherwise.
    066     */
    067    public boolean isGenericHandler(Class c);
    068
    069    /**
    070     * Returns the multiplex definition for the given class, or null, if no
    071     * such definition exists.
    072     *
    073     * @param c the class for which to check the existence of the multiplexer
    074     * @return the multiplexer for the class, or null if no multiplexer exists.
    075     */
    076    public MultiplexMappingDefinition getMultiplexDefinition(Class c);
    077
    078    /**
    079     * Returns the manual mapping definition for the given class, or null, if
    080     * not manual definition exists.
    081     *
    082     * @param c the class for which to check the existence of the definition
    083     * @return the manual mapping definition or null.
    084     */
    085    public ManualMappingDefinition getManualMappingDefinition(Class c);
    086
    087}